# Avoid running unnecessary services on the Praefect server
gitaly['enable'] = false
postgresql['enable'] = false
redis['enable'] = false
puma['enable'] = false
sidekiq['enable'] = false
gitlab_workhorse['enable'] = false
prometheus['enable'] = false
alertmanager['enable'] = false
grafana['enable'] = false
gitlab_exporter['enable'] = false
nginx['enable'] = false

# Praefect Configuration
praefect['enable'] = true
praefect['listen_addr'] = '0.0.0.0:2305'
praefect['auth_token'] = '{{ praefect_external_token }}'

{% if 'praefect_postgres' in groups %}
praefect['database_host'] = '{{ praefect_postgres_int_ip }}'
praefect['database_port'] = 5432
{% else %}
praefect['database_host'] = '{{ postgres_host }}'
praefect['database_port'] = '{{ postgres_port }}'
{% endif %}

praefect['database_user'] = '{{ praefect_postgres_username }}'
praefect['database_password'] = '{{ praefect_postgres_password }}'
praefect['database_dbname'] = '{{ praefect_postgres_database_name }}'

praefect['auto_migrate'] = {{ (db_migrate is defined and db_migrate == true) | lower }}

praefect['virtual_storages'] = {
  'default' => {
    'gitaly-1' => {
      'address' => 'tcp://{{ gitaly_primary_int_ip }}:8075',
      'token'   => '{{ praefect_internal_token }}'
    },
{% for ip in gitaly_secondary_int_ips %}
    'gitaly-{{ loop.index + 1 }}' => {
      'address' => 'tcp://{{ ip }}:8075',
      'token'   => '{{ praefect_internal_token }}'
    },
{% endfor %}
  }
}

gitlab_rails['rake_cache_clear'] = false
gitlab_rails['auto_migrate'] = false

# Consul
consul['enable'] = true
consul['configuration'] = {
  bind_addr: '{{ ansible_default_ipv4.address }}',
  retry_join: %w({{ (consul_int_ips if 'consul' in groups else gitlab_rails_int_ips) | join(' ') }})
}
consul['monitoring_service_discovery'] = true

# Monitoring
praefect['prometheus_listen_addr'] = '0.0.0.0:9652'
node_exporter['listen_address'] = '0.0.0.0:9100'

# Workaround for Sidekiq Cluster which is enabling by default
sidekiq['enable'] = false

custom_confs = Dir.glob(File.join("/etc/gitlab/", "gitlab.praefect.*.rb"))
custom_confs.each { |conf|
  from_file conf
}
